/*
 *  gopcodes.h
 *  G
 *
 *  Created by Christopher Huff on Wed Oct 16 2002.
 *  Copyright (c) 2002 Christopher Huff. All rights reserved.
 *
 */

#ifndef GOPCODES_H
#define GOPCODES_H

namespace g {

//opcodes are 64 bit unsigned integers, with 10 bits for the opcode (1024 max codes)
//and 54 bits for data

#define BinaryOpName(op) k##op##SSOp, k##op##SVOp, k##op##VSOp, k##op##VVOp, 
enum {
    //arithmetic
    //binary operators take 2 values off the numeric stack and
    //replace with 1 value. Top input value is rhs, next is lhs.
    BinaryOpName(Add)
    BinaryOpName(Sub)
    BinaryOpName(Mult)
    BinaryOpName(Div)
    BinaryOpName(Less)
    BinaryOpName(Greater)
    
    //stk has src data
    //opp stk gets converted data
    kMakeVectorOp,//scalar to vector
    kMakeScalarOp,//vector to scalar
    
    kGetXOp,
    kGetYOp,
    kGetZOp,
    
    //stk has src data
    //dest_data_idx:opcode(10)
    kSetLocalVectorOp,
    kSetLocalScalarOp,
    kSetGlobalVectorOp,
    kSetGlobalScalarOp,
    
    kPrintVectorOp,
    kPrintScalarOp,
    
    //stack push ops:
    //src_data_idx:opcode(10)
    kPushFunctionLocalOp,
    kPushScalarLocalOp,
    kPushVectorLocalOp,
    
    kPushFunctionGlobalOp,
    kPushScalarGlobalOp,
    kPushVectorGlobalOp,
    
    kPushFunctionConstantOp,
    kPushScalarConstantOp,
    kPushVectorConstantOp,
    
    //empty:opcode
    kPopScalarOp,
    kPopVectorOp,
    
    //flow
    kJumpOp,//jump to absolute location
    kCondJumpOp,
    kInvCondJumpOp,
    
    kFunctionCallOp,
    kVFunctionCallOp,
    kSFunctionCallOp,
    
    kVReturnOp,
    kSReturnOp,
    kReturnOp,
    kStopOp,
    kNoOp,
    kLastOp
};

}//namespace g

#endif
