
global_settings {
    assumed_gamma 1
}

camera {
    location < 0, 0,-5>
    look_at < 0, 0, 0>
    angle 45
}

light_source {<-50, 50,-50>, color rgb 1}
light_source {< 0, 0,-5>, color rgb 0.1}

plane {-z, -1
    texture {
        pigment {checker color rgb 0, color rgb 1}
        finish {ambient 0 diffuse 1}
    }
}

g "gpovtest.g"

#declare pointFn = function {g vector Position(scalar)}
#declare colorFn = function {g vector Color(vector)}

#declare J = 0;
#declare N = 3000;
#while(J < N)
    #declare ptA = pointFn(J/N);
    #declare ptB = pointFn((J+1)/N);
    union {
        sphere {ptA, 0.035}
        cylinder {ptA, ptB, 0.05}
        texture {
//            pigment {color rgb ptA/2 + 0.5}
            pigment {color rgb colorFn(ptA.x, ptA.y, ptA.z)}
            finish {
                ambient 0 diffuse 1
                specular 1 roughness 0.01
            }
        }
    }
    #declare J = J + 1;
#end
